#!/usr/bin/perl
### Perl CGI Script for SAM (Version 2.01) ###

use MIME::Base64;

############################################################################
# If your site don't use Japanese-characters,
# remove all "jcode" lines.
############################################################################
require 'jcode.pl';

############################################################################
## You have to change following variables
############################################################################
# root directory of MP3 files
local $g_root = '/data/MP3/';
local $g_baseurl='';

if( $ENV{'REMOTE_ADDR'} =~ /192\.168\.0\./ ){
	$g_baseurl = 'http://<Local Address>/jukubox/mp3.pl?PLAY=';
}
else{
	$g_baseurl = 'http://<host.domain>/jukubox/mp3.pl?PLAY=';
}

############################################################################
## If you use basic athorization, set 'id:passowrd' to $_auto in plain text.
##     (This script will encode by BASE64.)
## If not, set '' to $g_auth
############################################################################
local $g_auth = '';
#local $g_auth = 'userid:password';

############################################################################
## You had better change following variables.
## If your server is Windows, you should choose 'shift_jis'.
############################################################################

local $g_header_charset='euc-jp';
#local $g_header_charset = 'shift_jis';

local $g_html_convert_to = 'euc'; #for jcode::convert
#local $g_html_convert_to = 'sjis'; #for jcode::convert

local $g_filename_convert_to = 'sjis'; #for jcode

# Page Title
local $PAGETITLE = "MP3 Jukebox";

############################################################################
## Change following codes if you need.
############################################################################
my %params = parseHttpParam();

# $g_mp3file=0 : Make HTML for Download Lists
# $g_mp3file=1 : Make HTML for Direct Download
local $g_mp3file = 0;
## Make HTML for Direct Download (should be secret)
if( $params{'MP3FILE'} eq 'LINK' ){
	$g_mp3file = 1;
}

## Stream out MP3 File
if( $params{'PLAY'} ){
	play($params{'PLAY'});
	exit;
}

## Stream out MP3 Download List
if( $params{'ENQUEUE'} ){
	enqueue($params{'ENQUEUE'});
	exit;
}

## Set Current MP3 Directory
my $path = '';
if( defined $params{'PATH'} ){
	$path = $params{'PATH'} . '/';
}

## Browse Current MP3 Directory
browse($path);

################################################################
### sub browse()
###   output HTML
################################################################
sub browse($)
{
	my ($path) = @_;
	print "Content-type: text/html; charset=$g_header_charset\n\n";
	print "<html>";
	print "<head>\n";
	print "<title>$PAGETITLE</title>";
	outHead();
	print "</head>\n";
	
	print "<body bgcolor=#eeeeee>\n";
	print "<h1 align=center>$PAGETITLE</h1>\n";
	outBody($path);
	print "</body>\n";
	print "</html>\n";
}

######################################################
## outHead
######################################################
sub outHead()
{
print <<"HTML";
<meta http-equiv="Content-Type" content="text/html; charset=$g_header_charset">
<meta name="CHARSET" content="$g_header_charset">

<style type=\"text/css\">
a.black1:link { text-decoration: none; color: #000000; font-family: verdna; }
a.black1:hover { text-decoration: underline; color: #000000; font-family verdana; }
a.black1:visited { text-decoration: none; color: #000000; font-family: vrdana; }

a.white1:link { text-decoration: none; color: #ffffff; font-family: verdna; }
a.white1:hover { text-decoration: underline; color: #ffffff; font-family verdana; }
a.white1:visited { text-decoration: none; color: #ffffff; font-family: vrdana; }

a.blue1:link { text-decoration: none; color: #0000ff; font-family: verdan; }
a.blue1:hover { text-decoration: underline; color: #0000ff; font-family: erdana; }
a.blue1:visited { text-decoration: none; color: #0000ff; font-family: verana; }
</style>
HTML
}

################################################################
### outBody
################################################################
sub outBody($)
{
	my ($path) = @_;
	
	my @mp3s = ();
	my @dirs = ();

	outTree($path);
	globpath($path, \@mp3s, \@dirs);

	if( @mp3s ){
		$path =~ /\/$/;
		chop $path;
		my $link = urlEncode($path);

		print "<table border=0 width=100%>";
		print "<tr><th bgcolor=#000088 colspan=3><font color=#ffffffff>\n";
		print "<a class=white1 href=\"mp3.pl?ENQUEUE=$link\">";
		print "<img border=0 src=\"img/music.gif\"> Play All</a>";
		print "</font></th></tr>\n";
		print "<tr><th bgcolor=#000088><font color=#ffffffff>Title</th>\n";
		print "<th bgcolor=#000088><font color=#ffffffff>Artist</th>\n";
		print "<th bgcolor=#000088><font color=#ffffffff>Album</th></tr>\n";
		outDir('MP3', @mp3s);
		print "</table><p>\n";
	}

	if( @dirs ){
		foreach my $dir (@dirs){
			my @mp3s2 = ();
			my @dirs2 = ();
			my $disp = getdisp($dir);

			globpath($dir, \@mp3s2, \@dirs2);
			if( @mp3s2 ){
				my $link = urlEncode($dir);
				print "<table border=0 width=100%>\n<tr><td bgcolor=#000088><font color=#ffffffff><b>\n";
				print "<a class=white1 href=\"mp3.pl?PATH=$link\">";
				print "<img border=0 src=\"img/folder.gif\">  $disp</a>";

				print "  <a class=white1 href=\"mp3.pl?ENQUEUE=$link\">";
				print "<img border=0 src=\"img/music.gif\">  Play All</a>";
				print "</font></td></tr>\n<tr><td bgcolor=#ccccff>\n";
				outDir2('MP3', @mp3s2);
				print "</td></tr>\n</table><p>\n";
			}
		
			if( @dirs2 ){
				my $link = urlEncode($dir);
				print "<table border=0 width=100%><tr><td bgcolor=#000088><font color=#ffffffff><b>\n";
				print "<a class=white1 href=\"mp3.pl?PATH=$link\">";
				print "<img border=0 src=\"img/folder.gif\">  $disp</a>";
				print "</font></td></tr>\n<tr><td bgcolor=#ccccff>\n";
				outDir2('DIR', @dirs2);
				print "</td></tr>\n</table><p>\n";
			}
		}
	}

	print("<center><img src=img/apache_pb.gif></center>\n");
}

################################################################
### outTree
################################################################
sub outTree($)
{
	my ($path) = @_;
	my @dirs = split('/', $path);
	print "<a class=blue1 href=\"mp3.pl\"><img border=0 src=\"img/folder.gif\">  /</a><br>\n";
	$path = '';
	my $indent1 = "<img border=0 src=\"img/indent.gif\">";
	my $indent = '';
	for(my $i=0; $i<=$#dirs; $i++){
		$indent = $indent1 x ($i+1);
		$path .= '/' if($path);
		$path .= $dirs[$i];
		if( $i==$#dirs ){
			print "$indent<img src=\"img/folder.gif\">  ";
			print "<b>$dirs[$i]</b><br>\n";
		}
		else{
			print "$indent<a class=blue1 href=\"mp3.pl?PATH=$path\">";
			print "<img border=0 src=\"img/folder.gif\">  $dirs[$i]</a><br>\n";
		}
	}

	print 	"<p>\n";
}

################################################################
### outDir
################################################################
sub outDir($@)
{
	my ($type, @files) = @_;
	my $title = substr($id3, 3, 30);
	my $artist = '';
	my $album = '';
	my $year = '';
	my $comment = '';
	my $genre = '';

	foreach my $file (@files){
		my $mp3file = joinpath2($g_root, $file);
		getMP3Info($mp3file, \$size, \$title, \$artist, \$album);

		print "<tr><td bgcolor=#ccccff>";
		outTitle($file);
#		print ' (' . int($size/1024) .'KB)';
#		print "<td>$title</td>";
		print "</td><td bgcolor=#ccccff> $artist</td>";
		print "<td bgcolor=#ccccff>$album</td></tr>\n";
	}
}

################################################################
### outDir2
################################################################sub outDir2($@)
sub outDir2($@)
{
	my ($type, @files) = @_;

	foreach my $file (@files){
		outTitle($file);
		print " / ";
	}

}

################################################################
### outTitle($)
################################################################
sub outTitle($)
{
	my ($file) = @_;

	my $link = urlEncode($file);
	my $disp = getdisp($file);
	if( $file =~ /\.mp3|\.ogg/i ){
		my $verb = 'ENQUEUE';
		if( $g_mp3file ){
			$verb = 'PLAY';
		}
		print "<a class=black1 href=\"mp3.pl?$verb=$link\">";
		print "<img border=0 src=\"img/music.gif\"> $disp</a>";
	}
	else{
		print "<a class=black1 href=\"mp3.pl?PATH=$link\">";
		print "<img border=0 src=\"img/folder.gif\"> $disp</a> ";
		if( getmp3num($file)>0 ){
			print "  <a class=black1 href=\"mp3.pl?ENQUEUE=$link\">";
			print "<img border=0 src=\"img/music.gif\"></a>";
			print "</font>\n";
		}
	}
}

################################################################
### sub printMP3Info($)
################################################################
sub printMP3Info($)
{
	my ($path) = @_;
	my $size = '';
	my $title = '';
	my $artist = '';
	my $album = '';

	my $file = joinpath2($g_root, $path);
	getMP3Info($file, \$size, \$title, \$artist, \$album);
	
	print "$path|$size|$title|$artist|$album\n";
}
	
################################################################
### sub getMP3Info($$$$$)
################################################################
sub getMP3Info($$$$$)
{
	my ($path, $ref_size, $ref_title, $ref_artist, $ref_album) = @_;

	$$ref_size = 0;
	$$ref_title = undef;
	$$ref_artist = undef;
	$$ef_album = undef;

	$$ref_size = -s $path;
	if( open(IN, "<$path") ){
		binmode IN;
		seek IN, -128, 2;
		my $id3 = '';
		read(IN, $id3, 128);
		if( substr($id3, 0, 3) eq 'TAG' ){
			$$ref_title = substr($id3, 3, 30);
			jcode::convert($ref_title , $g_html_convert_to);
			$$ref_title =~ s/^\s+|\s+$//g;

			$$ref_artist = substr($id3, 33, 30);
			jcode::convert($ref_artist , $g_html_convert_to);
			$$ref_artist =~ s/^\s+|\s+$//g;

			$$ref_album = substr($id3, 63, 30);
			jcode::convert($ref_album , $g_html_convert_to);
			$$ref_album =~ s/^\s+|\s+$//g;

			$$ref_year = substr($id3, 93, 4);
			$$ref_year =~ s/^\s+|\s+$//g;

			$$ref_comment = substr($id3, 97, 30);
			jcode::convert($ref_comment , $g_html_convert_to);
			$$ref_comment =~ s/^\s+|\s+$//g;

			$$ref_genre = ord(substr($id3, 127, 1));
		}
		
		close(IN);
	}
}
################################################################
### joinpath($;$$$$$$$)
################################################################
sub joinpath($;$$$$$$$)
{
	my $path = join('/', @_);
	$path =~ s/\/\//\//g;
	
	$path =~ s/\\ /SLASPA/g;
	$path =~ s/ /\\ /g;
	$path =~ s/SLASPA/\\ /g;
	
	return $path;
}

################################################################
### joinpath2($;$$$$$$$)
################################################################
sub joinpath2($;$$$$$$$)
{
	my $path = join('/', @_);
	$path =~ s/\/\//\//g;
	return $path;
}

################################################################
### getfile($path)
################################################################
sub getfile($)
{
	my ($path) = @_;
	
	$path =~ /([^\/]+)$/;
	return $1;
}

################################################################
### getdisp($path)
################################################################
sub getdisp($)
{
	my ($path) = @_;
	my $name = getfile($path);
	$name =~ s/\.mp3$|\.ogg$//i;
	
	return $name;
}

################################################################
### globpath($@@)
################################################################
sub globpath($@@)
{
	my ($path, $ref_mp3s, $ref_dirs) = @_;

	my @files = glob(joinpath($g_root, $path, '*'));
	foreach my $file (@files){
		$file = substr($file, length $g_root);
		$file =~ s/^\/+|\/+$//;

		if( $file =~ /.mp3$|\.ogg$/i ){
			push @{$ref_mp3s}, $file;
		}
		elsif( -d joinpath2($g_root, $file) ){
			push @{$ref_dirs}, $file;
		}
	}

	@{$ref_mp3s} = sort  { uc($a) cmp uc($b) } @{$ref_mp3s};
	@{$ref_dirs} = sort  { uc($a) cmp uc($b) } @{$ref_dirs};

	return @{$ref_mp3s}?2:0 + @{$ref_dirs}?1:0;
}

################################################################
### getmp3num($)
################################################################
sub getmp3num($)
{
	my ($path) = @_;
	my @files1 = glob(joinpath($g_root, $path, '*.mp3'));
	my @files2 = glob(joinpath($g_root, $path, '*.ogg'));
	return $#files1+$#files2+2;
}

################################################################
### play
################################################################
sub play($)
{
	my ($path) = @_;

	my $file = joinpath2($g_root, $path);
	my $size = -s $file;
	if( $size==0 ){
		print "Content-type: text/html; charset=euc-jp\n\n";
		print "error";
		return;
	}

	my $filename = getfile($file);
	jcode::convert(\$filename , $g_filename_convert_to);

	print "Content-type: audio/mpeg\n";
	print "Content-Disposition: filename=$filename\n\n";
	open IN, "<$file" or die print "error";
	binmode IN;
	binmode STDOUT;
	while(read(IN, $buf, 2048)){
		print $buf;
	}
	close IN;
	return;
}

################################################################
### enqueue
################################################################
sub enqueue($)
{
	my ($path) = @_;
	
	my @mp3s = ();
	my @dirs = ();

	my $filename = getfile($path);
	jcode::convert(\$filename , $g_filename_convert_to);

	print "Content-type: application/download\n";
	print "Content-Disposition: filename=\"$filename.mpq\"\n\n";

	print "//" . chr(1) x 10 . "\n";
	print "//!baseurl $g_baseurl\n";
	if( $g_auth ){
		my $auth = encode_base64($g_auth);
		chomp $auth;
		print "//!auth $auth\n";
	}

	if( $path =~ /\.mp3$|\.ogg$/i ){
		printMP3Info($path);
	}
	else{
		globpath($path, \@mp3s, \@dirs);
		foreach my $mp3 (@mp3s){
			printMP3Info($mp3);
		}
	}
	
	return;
}



########################################################################
## parseHttpParam()
########################################################################
sub parseHttpParam()
{
	my($str, $param, @param, %param, $key, $val);

	if( $ENV{'REQUEST_METHOD'} eq 'POST' ){
		read( STDIN, $str, $ENV{'CONTENT_LENGTH'} );
	}
	else{
		$str = $ENV{'QUERY_STRING'};
	}
	
	@param = split('&', $str);
	foreach $param (@param)
	{
		($key, $val) = split('=', $param);
		if( defined $val )
		{
			$val = urlDecode($val);
			jcode::convert(\$val , $g_html_convert_to);
			$param{$key} = $val;
		}
	}
	
	%_ = %param;
}

########################################################################
## urlEncode($)
########################################################################
sub urlEncode($)
{
	my($str);
	($str) = @_;

	$str =~ s/([^\.\*\-_a-zA-Z0-9 ])/sprintf("%%%02lX",unpack("C",$1))/eg;
	$str =~ s/ /+/g;
	$_ = $str;
}

########################################################################
## urlDecode($)
########################################################################
sub urlDecode($)
{
	my($str);
	($str) = @_;

	$str =~ tr/+/ /;
	$str =~ s/%([a-zA-Z0-9][a-zA-Z0-9])/pack("C",hex($1))/eg;
	$_ = $str;
}

